VERSION 5.00
Begin VB.Form Status 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "AWD SMTP Mailer Service"
   ClientHeight    =   3840
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5640
   Icon            =   "Debug.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3840
   ScaleWidth      =   5640
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer retryswap 
      Left            =   4920
      Top             =   3720
   End
   Begin VB.CommandButton cmd_quit 
      Caption         =   "Quit"
      Height          =   495
      Left            =   3840
      TabIndex        =   3
      Top             =   3240
      Width           =   1695
   End
   Begin VB.CommandButton cmd_hide 
      Caption         =   "Hide"
      Height          =   495
      Left            =   1920
      TabIndex        =   2
      Top             =   3240
      Width           =   1815
   End
   Begin VB.CommandButton cmd_reset 
      Caption         =   "Clear Log"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   3240
      Width           =   1695
   End
   Begin VB.ListBox list_incoming 
      Height          =   2985
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   5415
   End
End
Attribute VB_Name = "Status"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'    Object: Background SMTP Mailer Process
'   Purpose: Sends e-mails recieved from MSMQ to SMTP server
'   Version: 1.0.0
' Author(s): Luke Bailey, for Pinnacle Publishing - Active Web Developer

' History
' v1.0.0 - 05/01/2002 - First implementation

Private requestqueue As MSMQQueue
Private retryaqueue As MSMQQueue
Private retrybqueue As MSMQQueue
Private WithEvents requestevent As MSMQEvent
Attribute requestevent.VB_VarHelpID = -1
Private WithEvents retryAevent As MSMQEvent
Attribute retryAevent.VB_VarHelpID = -1
Private WithEvents retrybevent  As MSMQEvent
Attribute retrybevent.VB_VarHelpID = -1
Dim msmq_name_incoming As String
Dim msmq_name_retryA As String
Dim msmq_name_retryB As String
Dim smtpserver As String
Dim logfile As String
Dim maxretry As Integer
Dim retry_rx As String
Dim retry_tx As String
Dim discount As Integer
Dim maxdispcount As Integer

'systray stuff
Private Type NOTIFYICONDATA
 cbSize As Long
 hwnd As Long
 uId As Long
 uFlags As Long
 uCallBackMessage As Long
 hIcon As Long
 szTip As String * 64
End Type
Private Const NIM_ADD = &H0
Private Const NIM_DELETE = &H2
Private Const WM_MOUSEMOVE = &H200
Private Const NIF_MESSAGE = &H1
Private Const NIF_ICON = &H2
Private Const NIF_TIP = &H4
Private Const WM_LBUTTONDBLCLK = &H203   'Double-click

Private Declare Function Shell_NotifyIcon Lib "shell32" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, pnid As NOTIFYICONDATA) As Boolean
Dim nid As NOTIFYICONDATA
'end systray stuff

Private Sub cmd_hide_Click()
 Status.Hide
End Sub

Private Sub cmd_quit_Click()
 Call Form_Unload(False)
End Sub

Private Sub cmd_reset_Click()
 On Error Resume Next
 list_incoming.Clear
End Sub

Private Sub Form_Load()
 On Error GoTo er_load
 
 'systray stuff
 If App.PrevInstance = False Then
       nid.cbSize = Len(nid)
       nid.hwnd = Status.hwnd
       nid.uId = vbNull
       nid.uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
       nid.uCallBackMessage = WM_MOUSEMOVE
       nid.hIcon = Status.Icon
       nid.szTip = "AWD SMTP Mailer.." & vbNullChar
       Shell_NotifyIcon NIM_ADD, nid
  End If
  ' end systray stuff
 
 ' Set options
 msmq_name_incoming = ".\private$\awd_mailer"
 msmq_name_retryA = ".\private$\awd_mailer_rA"
 msmq_name_retryB = ".\private$\awd_mailer_rB"
 smtpserver = "smtp.myisp.com"
 logfile = "d:\awdsmtp.log"
 dispcount = 0
 maxdispcount = 1000 'max no of lines in status window before auto-purge
 
 ' Intialise MSMQ
 Dim qi As MSMQQueueInfo
 Set qi = New MSMQQueueInfo
 qi.PathName = msmq_name_incoming
 Set requestqueue = qi.Open(MQ_RECEIVE_ACCESS, MQ_DENY_NONE)
 Set requestevent = New MSMQEvent
 requestqueue.EnableNotification requestevent
 qi.PathName = msmq_name_retryA
 Set retryaqueue = qi.Open(MQ_RECEIVE_ACCESS, MQ_DENY_NONE)
 Set retryAevent = New MSMQEvent
 retryaqueue.EnableNotification retryAevent
 qi.PathName = msmq_name_retryB
 Set retrybqueue = qi.Open(MQ_RECEIVE_ACCESS, MQ_DENY_NONE)
 Set retrybevent = New MSMQEvent
 retrybqueue.EnableNotification retrybevent
 list_incoming.Clear
 Status.Hide
 
 retry_tx = "B"
 retry_rx = "A"
 maxretry = 4
 retryswap.Interval = 60000 'One minute
 ' NB If you want a longer interval you will need a different timer as the
 'standard timer control only counts to up to slightly more than 1 minute.
 
 logevent "Server Initialised & Listening", ""
 Exit Sub
er_load:
 logevent "A critical error occured whilst starting up.", "(err=" + CStr(Err.Number) + ",source=" + CStr(Err.Source) + ",message=" + CStr(Err.message)
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
 On Error Resume Next
 Dim lMsg As Long
 lMsg = X / Screen.TwipsPerPixelX
 If lMsg = WM_LBUTTONDBLCLK Then Status.Show
End Sub

Private Sub Form_Unload(Cancel As Integer)
 On Error Resume Next
 'for systray stuff
 Shell_NotifyIcon NIM_DELETE, nid
 logevent "Server Terminated", ""
 End
End Sub

Private Sub requestevent_Arrived(ByVal queue As Object, ByVal Cursor As Long)
On Error GoTo er_requestevent
 Dim requestqueue As MSMQQueue
 Set requestqueue = queue
 Dim msg As MSMQMessage
 Set msg = requestqueue.Receive(ReceiveTimeOut:=0)
 If Not (msg Is Nothing) Then
 
  If msg.Label = "SMTPMailer-Inbound" Then
   If send_message(msg.Body) <> "OK" Then
    submit_retry msg.Body, maxretry
   End If
  Else
   logevent "Invalid message recieved (data is label)", CStr(msg.Label)
  End If
 End If
 
 requestqueue.EnableNotification requestevent
 Exit Sub
 
er_requestevent:
 On Error Resume Next
 requestqueue.EnableNotification requestevent
 Exit Sub
End Sub

Private Sub retryaevent_Arrived(ByVal queue As Object, ByVal Cursor As Long)
On Error GoTo er_retryaevent

If retry_rx = "A" Then

 Dim requestqueue As MSMQQueue
 Set requestqueue = queue
 Dim msg As MSMQMessage
 Set msg = requestqueue.Receive(ReceiveTimeOut:=0)
 If Not (msg Is Nothing) Then
 
  If Left(msg.Label, Len("SMTPMailer-Retry")) = "SMTPMailer-Retry" Then
   If send_message(msg.Body) <> "OK" Then
    retrycount = CInt(Right(msg.Label, Len(msg.Label) - Len("SMTPMailer-Retry:")))
    If retrycount > 0 Then
     submit_retry msg.Body, CInt(retrycount)
    Else
     logevent "Message discarded as retry=0", ""
    End If
   End If
  Else
   logevent "Invalid message received from retry queue", "Queue=A, Lable='" + msg.Label + "'"
  End If
 End If
 
 retryaqueue.EnableNotification retryAevent

 End If
 Exit Sub
 
er_retryaevent:
 On Error Resume Next
 retryaqueue.EnableNotification retryAevent
 Exit Sub
End Sub

Private Sub retrybevent_Arrived(ByVal queue As Object, ByVal Cursor As Long)
On Error GoTo er_retrybevent

If retry_rx = "B" Then

 Dim requestqueue As MSMQQueue
 Set requestqueue = queue
 Dim msg As MSMQMessage
 Set msg = requestqueue.Receive(ReceiveTimeOut:=0)
 If Not (msg Is Nothing) Then
 
  If Left(msg.Label, Len("SMTPMailer-Retry")) = "SMTPMailer-Retry" Then
   If send_message(msg.Body) <> "OK" Then
    retrycount = CInt(Right(msg.Label, Len(msg.Label) - Len("SMTPMailer-Retry:")))
    If retrycount > 0 Then
     submit_retry msg.Body, CInt(retrycount)
    Else
     logevent "Message discarded as retry=0", ""
    End If
   End If
  Else
   logevent "Invalid message received from retry queue", "Queue=B, Lable='" + msg.Label + "'"
  End If
  
 End If
  
 retrybqueue.EnableNotification retrybevent

 End If
 Exit Sub
 
er_retrybevent:
 On Error Resume Next
  retrybqueue.EnableNotification retrybevent
 Exit Sub
End Sub

Private Function send_message(thebody As String)
 On Error GoTo er_send_message
 
   Dim xmldoc As MSXML2.DOMDocument30
   Set xmldoc = New MSXML2.DOMDocument30
   xmldoc.loadXML (thebody)
   
   Dim mail As aspSmartMail.SmartMail
   Set mail = New aspSmartMail.SmartMail
   mail.Server = smtpserver
   
   mail.SenderAddress = xmldoc.getElementsByTagName("FROM").Item(0).Text
   mail.SenderName = xmldoc.getElementsByTagName("FROM-NAME").Item(0).Text
   Set recip = xmldoc.getElementsByTagName("TO")
   For a = 0 To (recip.length - 1)
    list_incoming.AddItem "Processing mail to: " + recip.Item(a).Text
    mail.Recipients.Add (recip.Item(a).Text)
   Next a
   mail.Subject = xmldoc.getElementsByTagName("SUBJECT").Item(0).Text
   mail.Body = xmldoc.getElementsByTagName("BODY").Item(0).Text
   Set atts = xmldoc.getElementsByTagName("FILE")
   For a = 0 To (atts.length - 1)
    mail.Attachments.Add (atts.Item(a).Text)
   Next a
   mail.XMailer = "AWD SMTP Mailer v1.0"
   On Error Resume Next
   mail.SendMail
   send_message = "ERR"
   If Err.Number <> 0 Then
    Select Case Err.Number
     Case 1, 10
      logevent "Unable to connect to specified SMTP server", ""
     Case 20
      logevent "SMTP server is connected but won't listen", ""
     Case 30
      logevent "SMTP server has rejected the senders addresses", ""
     Case 40
      logevent "SMTP server has rejected the recipient(s)", ""
     Case 50
      logevent "SMTP server is not ready to recieve your message", ""
     Case 60
      logevent "STMP server timed out whilst recieving your message", ""
     Case 70
      logevent "Unable to terminate session *nicely*", ""
     Case 100, 101
      logevent "Unable to locate/access specified attachment(s)", ""
     Case 200
      logevent "Recipient(s) addresses invalid", ""
     Case Else
      logevent "Undetermined event attepting to send mail (data is err code)", CStr(Err.Number)
    End Select
   Else
    send_message = "OK"
    display ("Message sent succesfully")
    logevent "Message sent sucessfully", ""
   End If
   Set mail = Nothing
   DoEvents
   Exit Function

er_send_message:
 send_message = "ERR"
 Exit Function
End Function

Private Sub submit_retry(thebody As String, prevcount As Integer)
 On Error GoTo submit_retry_error:
  'Open message queue
  Dim queueinfo As MSMQQueueInfo
  Set queueinfo = New MSMQQueueInfo
  If retry_tx = "A" Then
   queueinfo.PathName = msmq_name_retryA
  Else
   queueinfo.PathName = msmq_name_retryB
  End If
  Dim queue As MSMQQueue
  Set queue = queueinfo.Open(MQ_SEND_ACCESS, MQ_DENY_NONE)
 
  'Dispatch message
  Dim msg As MSMQMessage
  Set msg = New MSMQMessage
  msg.Label = "SMTPMailer-Retry:" + CStr(prevcount - 1)
  msg.Body = thebody
  msg.Priority = MQ_MAX_PRIORITY
  msg.Send queue
  queue.Close
 
  list_incoming.AddItem "Message added to retry queue '" + retry_tx + "'"
  logevent "Message submitted for retry to queue '" + retry_tx + "'", "Lable=" + "SMTPMailer-Retry:" + CStr(prevcount - 1)
  DoEvents
 
  'clean up
  Set msg = Nothing
  Set queue = Nothing
  Set queueinfo = Nothing
  Exit Sub

submit_retry_error:
 logevent "Unable to re-queue message for retry", "Queue=" + retry_tx
 Set msg = Nothing
 Set queue = Nothing
 Set queueinfo = Nothing
End Sub

Private Sub retryswap_Timer()
 On Error Resume Next
 If retry_rx = "A" Then
  retry_rx = "B"
  retry_tx = "A"
  retrybqueue.EnableNotification retrybevent
 Else
  retry_rx = "A"
  retry_tx = "B"
  retryaqueue.EnableNotification retryAevent
 End If
 logevent "Retry submission queue changed", "Submit=" + retry_tx + ", Process=" + retry_rx
 display ("Retry timer swap, rx=" + retry_rx + " / tx=" + retry_tx)
End Sub

Private Sub logevent(theevent As String, thedata As String)
 On Error GoTo er_logevent

  Open logfile For Append As #1
  Print #1, CStr(Now()) + " - " + theevent + " - " + thedata
  Close #1

 Exit Sub
er_logevent:
 App.logevent "AWD Mailer: Unable to write to log file.", 1
 Exit Sub
End Sub

Private Sub display(themessage)
 On Error Resume Next
 dispcount = dispcount + 1
 If dispcount < maxdispcount Then
  list_incoming.AddItem (themessage)
 Else
  list_incoming.Clear
  dispcount = 0
  display ("List auto-purged at " + CStr(Now()))
 End If
End Sub
